.stack-deploy:
  # variables:
  #   - STACK_NAME
  #   - DOCKET_AUTH_CONFIG for image
  image: registry-host.com/it/docker-xs-jq:0.0.5
  stage: deploy
  before_script:
  - json_xs -f yaml -t json < esim-subscriber-stack.yml | jq --raw-output 'select(.configs != null)| .configs | to_entries | map(select(.value | has("file")) | .key, .value.name, .value.file)[]' > configs.txt
      # Iterate over each three-tuple
  - | 
      while read entry; read name; read file
      do
        # Sanitize the variable name for the digest
        # sanitized_filename="$(echo $entry | sed 's/[./-]/_/g')"
        # echo "$entry.name: $sanitized_filename"
        remainder=$(( 63 - ${#entry} ))
        # Export a variable with the digest, truncate to a total of 64 characters
        DIGEST=$(sha512sum $file | awk '{print $1}' | cut -c -${remainder})
        sed -i "s/${entry}_DIGEST/${entry}_${DIGEST}/" $STACK_NAME-stack.yml
      done < configs.txt
  # Deploy the stack
  - echo $REGISTRY_PASSWORD | docker login -u $REGISTRY_USERNAME --password-stdin $REGISTRY_URL
  - echo '-------  $STACK_NAME-stack.yml -------'
  - cat *-stack.yml
  script:
    - echo "----- deploying stack mobifone -----"
    - docker stack deploy --prune --with-registry-auth -c $STACK_NAME-stack.yml $STACK_NAME
